Loading...
Searching...
No Matches
InternalPrimePower Class Reference

`#include <int_pp.h>`

## Public Member Functions

| InternalPrimePower ()
| InternalPrimePower (const InternalCF &)
| InternalPrimePower (const int i)
| InternalPrimePower (const char *str, const int base=10)
| InternalPrimePower (const mpz_ptr)
| ~InternalPrimePower ()
InternalCF * | deepCopyObject () const
const char * | classname () const
void | print (OSTREAM &, char *)
bool | isZero () const
bool | isOne () const
| bool InternalCF::isOne, isZero () const
InternalCF * | genZero ()
InternalCF * | genOne ()
InternalCF * | normalize_myself ()
bool | is_imm () const
int | levelcoeff () const
InternalCF * | neg ()
int | comparesame (InternalCF *)
InternalCF * | addsame (InternalCF *)
InternalCF * | subsame (InternalCF *)
InternalCF * | mulsame (InternalCF *)
InternalCF * | dividesame (InternalCF *)
InternalCF * | modulosame (InternalCF *)
InternalCF * | divsame (InternalCF *)
InternalCF * | modsame (InternalCF *)
void | divremsame (InternalCF *, InternalCF *&, InternalCF *&)
bool | divremsamet (InternalCF *, InternalCF *&, InternalCF *&)
int | comparecoeff (InternalCF *)
InternalCF * | addcoeff (InternalCF *)
InternalCF * | subcoeff (InternalCF *, bool)
InternalCF * | mulcoeff (InternalCF *)
InternalCF * | dividecoeff (InternalCF *, bool)
InternalCF * | modulocoeff (InternalCF *, bool)
InternalCF * | divcoeff (InternalCF *, bool)
InternalCF * | modcoeff (InternalCF *, bool)
void | divremcoeff (InternalCF *, InternalCF *&, InternalCF *&, bool)
bool | divremcoefft (InternalCF *, InternalCF *&, InternalCF *&, bool)
long | intval () const
int | intmod (int p) const
int | sign () const
Public Member Functions inherited from InternalCF
| InternalCF ()
| InternalCF (const InternalCF &)
virtual | ~InternalCF ()
int | deleteObject ()
InternalCF * | copyObject ()
virtual int | level () const
virtual int | type () const
virtual Variable | variable () const
virtual bool | inBaseDomain () const
virtual bool | inExtension () const
virtual bool | inCoeffDomain () const
virtual bool | inPolyDomain () const
virtual bool | inQuotDomain () const
virtual bool | isUnivariate () const
virtual InternalCF * | num ()
| InternalCF * InternalCF::num (), den ().
virtual InternalCF * | den ()
virtual InternalCF * | invert ()
virtual InternalCF * | tryInvert (const CanonicalForm &, bool &)
virtual InternalCF * | tryMulsame (InternalCF *, const CanonicalForm &)
virtual InternalCF * | tryDivsame (InternalCF *, const CanonicalForm &, bool &)
virtual bool | tryDivremsamet (InternalCF *, InternalCF *&, InternalCF *&, const CanonicalForm &, bool &)
virtual InternalCF * | tryDividecoeff (InternalCF *, bool, const CanonicalForm &, bool &)
virtual InternalCF * | tryDivcoeff (InternalCF *, bool, const CanonicalForm &, bool &)
virtual bool | tryDivremcoefft (InternalCF *, InternalCF *&, InternalCF *&, bool, const CanonicalForm &, bool &)
virtual InternalCF * | bgcdsame (const InternalCF *const) const
| InternalCF * InternalCF::bgcdsame, bgcdcoeff ( const InternalCF * const ).
virtual InternalCF * | bgcdcoeff (const InternalCF *const)
virtual InternalCF * | bextgcdsame (InternalCF *, CanonicalForm &, CanonicalForm &)
| InternalCF * InternalCF::bextgcdsame ( InternalCF *, CanonicalForm & a, CanonicalForm & b ).
virtual InternalCF * | bextgcdcoeff (InternalCF *, CanonicalForm &, CanonicalForm &)
virtual InternalCF * | sqrt ()
| InternalCF * InternalCF::sqrt ().
virtual int | ilog2 ()
| int InternalCF::ilog2 ()
virtual CanonicalForm | lc ()
| CanonicalForm InternalCF::lc (), Lc (), LC ().
virtual CanonicalForm | Lc ()
virtual CanonicalForm | LC ()
virtual CanonicalForm | coeff (int i)
| CanonicalForm InternalCF::coeff ( int i ).
virtual int | degree ()
| int InternalCF::degree ()
virtual int | taildegree ()
virtual CanonicalForm | tailcoeff ()
| CanonicalForm InternalCF::tailcoeff (), int InternalCF::taildegree ().
Public Member Functions inherited from omallocClass
void * | operator new (size_t size) throw (std::bad_alloc)
void | operator delete (void *block) throw ()
void * | operator new[] (size_t size) throw (std::bad_alloc)
void | operator delete[] (void *block) throw ()
void * | operator new (size_t size, const std::nothrow_t &) throw ()
void * | operator new[] (size_t size, const std::nothrow_t &) throw ()

## Static Public Member Functions

static void | setPrimePower (int p, int k)

## Data Fields

STATIC_VAR mpz_t | primepow
STATIC_VAR mpz_t | primepowhalf

## Static Private Member Functions

static void | initialize ()
static mpz_ptr | MPI (const InternalCF *const c)

## Private Attributes

mpz_t | thempi
STATIC_VAR bool | initialized
STATIC_VAR int | prime
STATIC_VAR int | exp

## Friends

void | getmpi (InternalCF *value, mpz_t mpi)

## Additional Inherited Members

Protected Member Functions inherited from InternalCF
int | getRefCount ()
void | incRefCount ()
int | decRefCount ()

## Detailed Description

Definition at line 26 of file int_pp.h.

## Constructor & Destructor Documentation

## InternalPrimePower() [1/5]

InternalPrimePower::InternalPrimePower | ( |  | ) |

## InternalPrimePower() [2/5]

InternalPrimePower::InternalPrimePower | ( | const InternalCF & |  | ) |

inline

Definition at line 39 of file int_pp.h.

{
ASSERT( 0, "ups there is something wrong in your code" );
}
ASSERT
#define ASSERT(expression, message)
Definition cf_assert.h:99

## InternalPrimePower() [3/5]

InternalPrimePower::InternalPrimePower | ( | const int | i | ) |

## InternalPrimePower() [4/5]

InternalPrimePower::InternalPrimePower | ( | const char * | str,
|  | const int | base = 10 )

## InternalPrimePower() [5/5]

InternalPrimePower::InternalPrimePower | ( | const mpz_ptr |  | ) |

## ~InternalPrimePower()

InternalPrimePower::~InternalPrimePower | ( |  | ) |

## Member Function Documentation

## addcoeff()

InternalCF * InternalPrimePower::addcoeff | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## addsame()

InternalCF * InternalPrimePower::addsame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## classname()

const char * InternalPrimePower::classname | ( |  | ) | const

inline virtual

Reimplemented from InternalCF.

Definition at line 48 of file int_pp.h.

{ return "InternalPrimePower"; }

## comparecoeff()

int InternalPrimePower::comparecoeff | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## comparesame()

int InternalPrimePower::comparesame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## deepCopyObject()

InternalCF * InternalPrimePower::deepCopyObject | ( |  | ) | const

virtual

Reimplemented from InternalCF.

## divcoeff()

InternalCF * InternalPrimePower::divcoeff | ( | InternalCF * | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## dividecoeff()

InternalCF * InternalPrimePower::dividecoeff | ( | InternalCF * | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## dividesame()

InternalCF * InternalPrimePower::dividesame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## divremcoeff()

void InternalPrimePower::divremcoeff | ( | InternalCF * | ,
|  | InternalCF *& | ,
|  | InternalCF *& | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## divremcoefft()

bool InternalPrimePower::divremcoefft | ( | InternalCF * | ,
|  | InternalCF *& | ,
|  | InternalCF *& | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## divremsame()

void InternalPrimePower::divremsame | ( | InternalCF * | ,
|  | InternalCF *& | ,
|  | InternalCF *& | )

virtual

Reimplemented from InternalCF.

## divremsamet()

bool InternalPrimePower::divremsamet | ( | InternalCF * | ,
|  | InternalCF *& | ,
|  | InternalCF *& | )

virtual

Reimplemented from InternalCF.

## divsame()

InternalCF * InternalPrimePower::divsame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## genOne()

InternalCF * InternalPrimePower::genOne | ( |  | ) |

virtual

Reimplemented from InternalCF.

## genZero()

InternalCF * InternalPrimePower::genZero | ( |  | ) |

virtual

Reimplemented from InternalCF.

## initialize()

void InternalPrimePower::initialize | ( |  | ) |

static private

## intmod()

int InternalPrimePower::intmod | ( | int | p | ) | const

virtual

Reimplemented from InternalCF.

## intval()

long InternalPrimePower::intval | ( |  | ) | const

virtual

Reimplemented from InternalCF.

## is_imm()

bool InternalPrimePower::is_imm | ( |  | ) | const

## isOne()

bool InternalPrimePower::isOne | ( |  | ) | const

virtual

bool InternalCF::isOne, isZero () const

See also
  CanonicalForm::isOne(), CanonicalForm::isZero()

Reimplemented from InternalCF.

## isZero()

bool InternalPrimePower::isZero | ( |  | ) | const

virtual

Reimplemented from InternalCF.

## levelcoeff()

int InternalPrimePower::levelcoeff | ( |  | ) | const

inline virtual

Reimplemented from InternalCF.

Definition at line 62 of file int_pp.h.

{ return PrimePowerDomain; }
PrimePowerDomain
#define PrimePowerDomain
Definition cf_defs.h:17

## modcoeff()

InternalCF * InternalPrimePower::modcoeff | ( | InternalCF * | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## modsame()

InternalCF * InternalPrimePower::modsame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## modulocoeff()

InternalCF * InternalPrimePower::modulocoeff | ( | InternalCF * | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## modulosame()

InternalCF * InternalPrimePower::modulosame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## MPI()

mpz_ptr InternalPrimePower::MPI | ( | const InternalCF *const | c | ) |

inline static private

Definition at line 97 of file int_pp.h.

{
return (((InternalPrimePower*)c)->thempi);
}
InternalPrimePower::InternalPrimePower
InternalPrimePower()
InternalPrimePower::thempi
mpz_t thempi
Definition int_pp.h:29

## mulcoeff()

InternalCF * InternalPrimePower::mulcoeff | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## mulsame()

InternalCF * InternalPrimePower::mulsame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## neg()

InternalCF * InternalPrimePower::neg | ( |  | ) |

virtual

Reimplemented from InternalCF.

## normalize_myself()

InternalCF * InternalPrimePower::normalize_myself | ( |  | ) |

## print()

void InternalPrimePower::print | ( | OSTREAM & | ,
|  | char * | )

virtual

Reimplemented from InternalCF.

## setPrimePower()

void InternalPrimePower::setPrimePower | ( | int | p,
|  | int | k )

static

## sign()

int InternalPrimePower::sign | ( |  | ) | const

virtual

Reimplemented from InternalCF.

## subcoeff()

InternalCF * InternalPrimePower::subcoeff | ( | InternalCF * | ,
|  | bool | )

virtual

Reimplemented from InternalCF.

## subsame()

InternalCF * InternalPrimePower::subsame | ( | InternalCF * |  | ) |

virtual

Reimplemented from InternalCF.

## Friends And Related Symbol Documentation

## getmpi

void getmpi | ( | InternalCF * | value,
|  | mpz_t | mpi )

friend

Definition at line 303 of file cf_factory.cc.

{
ASSERT( ! is_imm( value ) && (value->levelcoeff() == IntegerDomain || value->levelcoeff() == PrimePowerDomain), "illegal operation" );
mpz_init_set (mpi, ((InternalInteger*)value)->thempi);
}
IntegerDomain
#define IntegerDomain
Definition cf_defs.h:21
InternalCF::levelcoeff
virtual int levelcoeff() const
Definition int_cf.h:68
InternalPrimePower::is_imm
bool is_imm() const

## Field Documentation

## exp

STATIC_VAR int InternalPrimePower::exp

private

Definition at line 32 of file int_pp.h.

## initialized

STATIC_VAR bool InternalPrimePower::initialized

private

Definition at line 30 of file int_pp.h.

## prime

STATIC_VAR int InternalPrimePower::prime

private

Definition at line 31 of file int_pp.h.

## primepow

STATIC_VAR mpz_t InternalPrimePower::primepow

Definition at line 36 of file int_pp.h.

## primepowhalf

STATIC_VAR mpz_t InternalPrimePower::primepowhalf

Definition at line 37 of file int_pp.h.

## thempi

mpz_t InternalPrimePower::thempi

private

Definition at line 29 of file int_pp.h.

The documentation for this class was generated from the following file:

- factory/int_pp.h